#include "App.h"
#include "LED.h"
#include "key.h"
#include "stdio.h"
#include "BIOS.h"

uint8_t DISP_Status;
uint32_t ulState_Timer = 0;
bool DATA_READY = FALSE, TIME_8MS = FALSE;
bool RX_READY = FALSE, DATA_READY_ADC = FALSE;
bool TX_TRIGGER = FALSE, TX_RQ = FALSE, TX_TIME = FALSE;
bool LED_flag = TRUE;

uint8_t ucLED_FlashCnt = 0;
uint16_t TRX_Cnt = 0;
uint8_t ucTXMode = MODE_TX_SINGLE;

uint8_t status = 0;

/**
 * @brief  TX/RX״̬ѡ
 * @param  None
 * @retval None
 */
void APP_StateMachine(void)
{
    if (Work_State == FUNCTION_RX)
    {
        APP_RX_Normal();
    }
    else if (Work_State == FUNCTION_TX)
    {
        APP_TX_Normal();
    }
}

/**
 * @brief  RX״̬¼ݰͳƣLEDʾģʽ
 * @param  None
 * @retval None
 */
void APP_RX_Event(void)
{
    if (RX_READY) /* RFյݰ */
    {
#ifdef DEBUG_EN
        // printf("RX_Event:%x\n",TRX_Cnt);                                        /* DEMOTX 4msһΣRXϴӡᶪʧ */
#endif
        RX_READY = FALSE;
        TRX_Cnt++; /* RX Count1 */
        if (DISP_Status == LED_CNT_MODE)
        {
            LED_ChangeFont(TRX_Cnt, LED_CNT_MODE);
            DISP_Status = LED_CNT_MODE;
        }
    }

    if (DATA_READY) /* а¼ */
    {
        DATA_READY = FALSE;
        if (flag_key_one_shot)
        {
            if (ucKey_RD == 0x00)
            {
                flag_key_one_shot = 0;
                return;
            }
            return;
        }

        if (ucKey_RD == KEY1)
        {
            if (DISP_Status == LED_CNT_MODE)
            {
#ifdef DEBUG_EN
                printf("Clear cnt\n");
#endif
                TRX_Cnt = 0; /* RXհ */
            }
            LED_ChangeFont(TRX_Cnt, LED_CNT_MODE); /* ʾģʽ */
            DISP_Status = LED_CNT_MODE;
        }
        else if (ucKey_RD == KEY2)
        {
#ifdef DEBUG_EN
            printf("key 2\n");
#endif
        }
        else if (ucKey_RD == KEY3)
        {
            if (DISP_Status == LED_CHANNEL_MODE)
            {
                RFAPI_ChannelNext(); /* RFлһƵ */ // Set RF work in RX mode
            }
            LED_ChangeFont(CHANNEL_TABLE[Channel_Index], LED_CHANNEL_MODE);
            DISP_Status = LED_CHANNEL_MODE;
#ifdef DEBUG_EN
            printf("Hop channel:%d\n", (int)CHANNEL_TABLE[Channel_Index]);
#endif
        }
    }
}

/**
 * @brief  RXģʽ
 * @param  None
 * @retval None
 */
void APP_RX_Normal(void)
{
    APP_RX_Event(); /* RX״̬¼ */
    Key_Scan();     /* ɨ */
    LED_Display();  /* LEDʾ */
}

/**
 * @brief  TX״ַ̬ģʽл
 *         Switch between:Function A,B and C
 *         A:  single TX
 *         B:  1000packet TX
 *         C:  continues TX
 * @param  None
 * @retval None
 */
void APP_TXMODE_Swtich(void)
{
    if (ucTXMode == MODE_TX_SINGLE)
    {
        ucTXMode = MODE_TX_1000PACK; /* Switch into B */
        TRX_Cnt = 1000;
    }
    else if (ucTXMode == MODE_TX_1000PACK)
    {
        ucTXMode = MODE_TX_CONTINUE; /* Switch into C */
        TRX_Cnt = 0;
    }
    else
    {
        ucTXMode = MODE_TX_SINGLE; /* Switch into A */
        TRX_Cnt = 0;
    }
}

/**
 * @brief  TX״̬¼LEDʾģʽ
 * @param  None
 * @retval None
 */
void APP_TX_Event(void)
{
    if (DATA_READY) /* а¼ */
    {
        DATA_READY = FALSE;
        if (flag_key_one_shot) /* ϵһΰ¼ִж */
        {
            if (ucKey_RD == 0x00)
            {
                flag_key_one_shot = 0;
                return;
            }
            return;
        }

        if (ucKey_RD == KEY1)
        {
            TX_TRIGGER = FALSE;
            if (DISP_Status == LED_FUNCTION_MODE)
            {
                APP_TXMODE_Swtich(); /* ģʽл */
#ifdef DEBUG_EN
                printf("function switch:%x\n", ucTXMode);
#endif
            }
            else
            {
                if (ucTXMode == MODE_TX_SINGLE)
                {
                    TRX_Cnt = 0;
                }
                else if (ucTXMode == MODE_TX_1000PACK)
                {
                    TRX_Cnt = 1000;
                    status = 0;
                }
                else
                {
                    TRX_Cnt = 0;
                }
            }
            DISP_Status = LED_FUNCTION_MODE;
            LED_ChangeFont(ucTXMode, LED_FUNCTION_MODE);
        }
        else if (ucKey_RD == KEY2)
        {
            if (TX_TRIGGER) /* ʼ/ͣ */
            {
                TX_TRIGGER = FALSE;
            }
            else
            {
                TX_TRIGGER = TRUE;
            }

#ifdef DEBUG_EN
            printf("start trigger\n");
#endif
        }
        else if (ucKey_RD == KEY3)
        {
            if (DISP_Status == LED_CHANNEL_MODE)
            {
                RFAPI_ChannelNext(); /* лһƵ */
#ifdef DEBUG_EN
                printf("Hop channel:%d\n", (int)CHANNEL_TABLE[Channel_Index]);
#endif
            }
            TX_TRIGGER = FALSE;
            DISP_Status = LED_CHANNEL_MODE;
            LED_ChangeFont(CHANNEL_TABLE[Channel_Index], LED_CHANNEL_MODE);
        }
    }

    /* жǷҪݷ */
    if ((TX_TRIGGER) && (TX_TIME) && (ucRFAPI_STATE == RFAPI_TX))
    {
        TX_TIME = FALSE;
        TX_RQ = TRUE; /* ʹܷ */

        if (ucTXMode == MODE_TX_SINGLE)
        {
            TRX_Cnt++;
            TX_TRIGGER = FALSE;
#ifdef DEBUG_EN
            printf("trigger stop\n");
#endif
        }
        else if (ucTXMode == MODE_TX_CONTINUE)
        {
            TRX_Cnt++;
            if (TRX_Cnt >= 9999)
            {
                TRX_Cnt = 0;
            }
        }
        else
        {
            if (TRX_Cnt > 0)
            {
                TRX_Cnt--;
            }
            else
            {
                TRX_Cnt = 1000;
                TX_RQ = FALSE;
                TX_TRIGGER = FALSE;
#ifdef DEBUG_EN
                printf("trigger stop\n");
#endif
            }
        }
        LED_ChangeFont(TRX_Cnt, LED_CNT_MODE);
        DISP_Status = LED_CNT_MODE;
    }
}

/**
 * @brief  TXģʽ
 * @param  None
 * @retval None
 */
void APP_TX_Normal(void)
{
    APP_TX_Event();
    LED_Display();
    Key_Scan();
}
