#include "App.h"
#include "LED.h"
#include "key.h"
#include "stdio.h"
#include "pan1026.h"
#include "pan1026_user.h"
#include "config_rf.h"
#include "RFAPI.h"
#include "BIOS.h"
bool bRFAPI_IRQ = FALSE;
bool flag_flush = TRUE;
enum RFAPI_CommuSate ucRFAPI_STATE;

uint8_t Channel_Index = 18; /* ĬΪ2478Mhz */
uint8_t const CHANNEL_TABLE[] = {2, 6, 10, 14, 18, 22, 26, 30, 34, 38, 42, 46, 50, 54, 58, 62, 66, 70, 78, 80};
uint8_t const CHANNEL_TABLE_CARRIER[] = {2, 50, 78};
static uint8_t tx_data[CONFIG_PAYLOAD_WIDTH] = {0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08};
static uint8_t rx_len;
static uint8_t rx_data[64];
static uint8_t ble_tx_data[39] = {
    0x42, 0x25,
    0x66, 0x55, 0x44, 0x33, 0x22, 0x11,
    0x05, 0x09, 'T', 'E', 'M', 'P',
    0x02, 0x01, 0x1A,
    0x15, 0xFF, 0xF0, 0xFF, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09,
    0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18

};

/**
 * @brief  ÷
 * @param  None
 * @retval None
 */
void RFAPI_PacketData(void)
{
    tx_data[0] = 0x01;
    tx_data[1] = 0x02;
    tx_data[2] = 0x03;
    tx_data[3] = 0x04;
    tx_data[4] = 0x05;
    tx_data[5] = 0x06;
    tx_data[6] = 0x07;
    tx_data[7] = 0x08;
}

/**
 * @brief  лŵеһƵ
 * @param  None
 * @retval None
 */
void RFAPI_ChannelNext(void)
{
    if ((Channel_Index == 0) || (Channel_Index >= sizeof(CHANNEL_TABLE)))
    {
        Channel_Index = sizeof(CHANNEL_TABLE) - 1;
    }
    else
    {
        Channel_Index--;
    }
    pan1026_set_channel(CHANNEL_TABLE[Channel_Index]);
}

/**
 * @brief  TX״̬·ݴ
 * @param  None
 * @retval None
 */
void RFAPI_TxState(void)
{
    if (!(TX_RQ)) /* Ҫ */
    {
        return;
    }
    TX_RQ = FALSE;

    RFAPI_PacketData();

    /* ǿģʽ  ACK PAYLAOD*/
    if ((ucTest_Mode == TEST_DEFAULT_MODE) && ((CONFIG_WORK_MODE & 0x01) == 1) && (CONFIG_ACK_PAY == ENABLE_ACK_PAY))
    {
        rx_len = pan1026_user_tx_enhance(tx_data, CONFIG_PAYLOAD_WIDTH, rx_data, 64);
        if (rx_len > 0)
        {
            printf("trx ok \r\n");
            printf("rx len: %d\r\n", rx_len);
            printf("data: ");
            for (uint8_t i = 0; i < rx_len; i++)
            {
                printf("%02x ", rx_data[i]);
            }
        }
        else
        {
            printf("trx err \r\n");
        }
    }
    else
    {
        /* ģʽ׼㲥ֽڳ39bytes */
        if (((ucTest_Mode == TEST_DEFAULT_MODE) && (CONFIG_WORK_MODE == PAN1026_BLE_MODE)) || (ucTest_Mode == TEST_BLE_MODE))
        {
            if (PAN1026_TX_DONE == pan1026_user_tx(ble_tx_data, 39))
            {
                printf("tx ok \r\n");
            }
            else
            {
                printf("tx err \r\n");
            }
        }
        else
        {
            if (PAN1026_TX_DONE == pan1026_user_tx(tx_data, CONFIG_PAYLOAD_WIDTH))
            {
                printf("tx ok \r\n");
            }
            else
            {
                printf("tx err \r\n");
            }
        }
    }
}

/**
 * @brief  RX״̬½ݴ
 * @param  None
 * @retval None
 */
void RFAPI_RXState(bool RX_Continue)
{
    /* ǿģʽ */
    if ((ucTest_Mode == TEST_DEFAULT_MODE) && ((CONFIG_WORK_MODE & 0x01) == 1))
    {
#if (CONFIG_ACK_PAY == ENABLE_ACK_PAY) /* ACK PAYLAOD */
        rx_len = pan1026_user_rx_enhance_ackpayload(rx_data, 64, tx_data, CONFIG_PAYLOAD_WIDTH);
#else
        rx_len = pan1026_user_rx_enhance(rx_data, 64);
#endif
    }
    else
    {
        rx_len = pan1026_user_rx(rx_data, 64);
    }

    if (rx_len > 0)
    {
#if 0 /* ӡݱȽϺʱһ㲻 */
        printf("rx len: %d\r\n", rx_len);
        printf("data: ");
        for (uint8_t i = 0; i < rx_len; i++)
        {
           printf("%02x ", rx_data[i]);
        }
#endif
        ucRFAPI_STATE = RFAPI_RX;
        RX_READY = TRUE;
        PB09_TOG();
    }
}

/**
 * @brief  RFͬģʽѡ񣬸ϵʱ״̬ѡ벻ͬģʽ
 * @param  None
 * @retval None
 */
void RFAPI_SelectMode(void)
{
    if (ucTest_Mode == TEST_DEFAULT_MODE) /* TEST_DEFAULT_MODE, Ĭģʽ */
    {
#ifdef DEBUG_EN
        printf("DEFAULT MODE\r\n");
#endif
        flag_key_one_shot = 1;
        return;
    }
    else if (ucTest_Mode == TEST_BLE_MODE)
    {
#ifdef DEBUG_EN
        printf("BLE MODE\r\n");
#endif
        flag_key_one_shot = 1;
        pan1026_set_mode(PAN1026_BLE_MODE);
        return;
    }
    else if (ucTest_Mode == TEST_CARRIER_MODE)
    {
#ifdef DEBUG_EN
        printf("CARRIER MODE\r\n");
#endif
        pan1026_carrier();
        LED_ChangeFont(CONFIG_CHANNEL, LED_FUNCTION_MODE);

        while (1)
        {
            Key_Scan();
            if (DATA_READY) /* а¼ */
            {
                DATA_READY = FALSE;
                if (ucKey_RD == KEY3)
                {
                    if ((Channel_Index == 0) || (Channel_Index >= sizeof(CHANNEL_TABLE_CARRIER)))
                    {
                        Channel_Index = sizeof(CHANNEL_TABLE_CARRIER) - 1;
                    }
                    else
                    {
                        Channel_Index--;
                    }
                    pan1026_set_channel(CHANNEL_TABLE_CARRIER[Channel_Index]); // set RF into carry mode
                    LED_ChangeFont(CHANNEL_TABLE_CARRIER[Channel_Index], LED_FUNCTION_MODE);
                }
            }
            LED_Display();
        }
    }
    else
    {
        ucTest_Mode = TEST_DEFAULT_MODE;
    }
}

/**
 * @brief  TX/RX״̬ѡ
 * @param  None
 * @retval None
 */
void RFAPI_StateMachine(void)
{
    switch (ucRFAPI_STATE)
    {
    case RFAPI_TX:
        RFAPI_TxState();
        break;
    case RFAPI_RX:
        RFAPI_RXState(TRUE);
        break;
    case RFAPI_HALT:
        break;
    default:
        break;
    }
}
