#ifndef _PAN1026_H
#define _PAN1026_H

#include "cw32r031.h"

#define CONFIG_CHIP_VERSION         PAN1026_VERSION_D           /* D汾Բ */


/* ӿ */
typedef struct
{
    /**
      * @brief  ַָдָ
      * @param  addr  ָĵַ
      * @param  buf   д
      * @param  len   дݵĳ, ֽΪλ
      * @retval None
      */
    void (*rf_write_buf)(uint8_t addr, uint8_t *buf, uint8_t len);

    /**
      * @brief  ַָȡָ
      * @param  addr  ָĵַ
      * @param  buf   ȡݵĴ洢ռ
      * @param  len   ȡݵĳ, ֽΪλ
      * @retval None
      */
    void (*rf_read_buf)(uint8_t addr, uint8_t *buf, uint8_t len);

}pan1026_com_interface;



/******************************  оƬ汾   ***********************************/
#define PAN1026_VERSION_A        1
#define PAN1026_VERSION_B        2
#define PAN1026_VERSION_D        3


/******************************  ʽ   ***********************************/
#define PAN1026_SPI_MODE           0       /* ׼SPI */
#define PAN1026_I2C_MODE           1       /* I2C */
#define PAN1026_SPI_NO_MOSI_MODE   2       /* SPI */



/********************************    IRQ   ************************************/
#define PAN1026_IRQ_DISABLE         0x00          
#define PAN1026_IRQ_ENABLE          0x01    /* MCUɲѯIRQĵƽͨIRQMCUжϻ֪1026״̬; ע: PAN1026ֻQFNװIRQ */



/******************************  CRC   ************************************/
#define PAN1026_CRC16            0x06     /* CRC16 */
#define PAN1026_CRC8             0x02     /* CRC8 */ 
#define PAN1026_CRC_DISABLE      0x00     /* رCRC */



/******************************     ************************************/
#define PAN1026_SCR_ENABLE       0x01    /*  */
#define PAN1026_SCR_DISABLE      0x00    /* ر */



/*****************************  BLEչ   *********************************/
#define PAN1026_BLE_FILTER_DISABLE   0x00   /*  */
#define PAN1026_BLE_FILTER_1BYTE     0x01   /* 1ֽ */
#define PAN1026_BLE_FILTER_2BYTE     0x02   /* 2ֽ */


/******************************  TX/RXģʽ   **********************************/
#define PAN1026_TX_MODE              0x00   /* TX MODE */
#define PAN1026_RX_MODE              0x01   /* RX MODE */



/******************************  ģʽ   ***********************************/
#define PAN1026_BURST_MODE           0x00   /* XN297Lͨ */
#define PAN1026_ENHANCE_MODE         0x01   /* XN297Lǿ */
#define PAN1026_BLE_MODE             0x10   /* BLEģʽ */


   
/******************************  ʵλ   ***********************************/
#define	PAN1026_POWER_P_6	  0xc9c2	 /* 6dbm */
#define	PAN1026_POWER_P_3	  0x49c6	 /* 3dbm */
#define	PAN1026_POWER_P_2	  0x49c2	 /* 2dbm */
#define	PAN1026_POWER_P_1	  0xc9c5	 /* 1dbm */
#define	PAN1026_POWER_P_0	  0xc9c1	 /* 0dbm */
#define	PAN1026_POWER_N_8	  0x49c1	 /* -8dbm */

#if(CONFIG_CHIP_VERSION == PAN1026_VERSION_D)
  #define	PAN1026_POWER_P_10	  0xc9ca	 /* 10dbm */
#else
  #define	PAN1026_POWER_P_8	  0xc9ca	 /* 8dbm */
#endif



/******************************  ʵλ   ***********************************/
#define	PAN1026_RATE_1M           0         /* 1Mbps */ 
#define	PAN1026_RATE_2M           1         /* 2Mbps */



/******************************  ״̬־   ***********************************/
#define	PAN1026_STA_NONE          0x00      /* κ״̬ */
#define	PAN1026_TX_DONE           0x20      /* ͳɹ */ 
#define	PAN1026_RX_DONE           0x40      /* ճɹ */
#define	PAN1026_TRX_DONE          0x60      /* ͳɹյACK Payload, ǿģʽ */
#define	PAN1026_TX_MAX_ERR        0x10      /* ݵδյACK, ǿģʽ */



/******************************     ***********************************/
#define PAN1026_W_PAGE_OF_1P8V_REG    0xF0
#define PAN1026_R_PAGE_OF_1P8V_REG    0xFE
#define PAN1026_R_REGISTER            0x00
#define PAN1026_W_REGISTER            0x20
#define PAN1026_R_RX_PAYLOAD          0x61
#define PAN1026_W_TX_PAYLOAD          0xA0
#define PAN1026_FLUSH_TX              0xE1
#define PAN1026_FLUSH_RX              0xE2
#define PAN1026_REUSE_TX_PL           0xE3
#define PAN1026_ACTIVATE              0x50
#define PAN1026_DEACTIVATE            0x50
#define PAN1026_R_RX_PL_WID           0x60
#define PAN1026_W_ACK_PAYLOAD         0xA8  /* (A8+x,xΪͨ) */
#define PAN1026_W_TX_PAYLOAD_NOACK    0xB0 
#define PAN1026_3V_REG0_WR            0xF1
#define PAN1026_3V_REG0_RD            0xF2
#define PAN1026_3V_REG1_WR            0xF3
#define PAN1026_3V_REG1_RD            0xF4
#define PAN1026_CE_SPI_ON             0xFD
#define PAN1026_CE_SPI_OFF            0xFC
#define PAN1026_CE_SPI_ON             0xFD
#define PAN1026_RST_SPI_HOLD          0x53
#define PAN1026_RST_SPI_RELS          0x53


/************************  1.8V PAGE 0 Ĵ   ***************************/
#define PAN1026_CONFIG                0x00
#define PAN1026_EN_AA                 0x01
#define PAN1026_AW_RXADDR             0x02
#define PAN1026_SETUP_RX              0x03
#define PAN1026_SETUP_RETR            0x04
#define PAN1026_RF_CH                 0x05
#define PAN1026_SETUP_RXTX            0x06
#define PAN1026_STATUS                0x07
#define PAN1026_OBSERVE_TX            0x08
#define PAN1026_DATAOUT               0x09
#define PAN1026_RX_ADDR_P0            0x0A
#define PAN1026_RX_ADDR_P1            0x0B
#define PAN1026_RX_ADDR_P2P3          0x0C
#define PAN1026_RX_ADDR_P4P5          0x0D
#define PAN1026_SETUP_RF              0x0E
#define PAN1026_AGC_TABLE             0x0F
#define PAN1026_TX_ADDR               0x10
#define PAN1026_RX_PW_P0              0x11
#define PAN1026_RX_PW_P1              0x12
#define PAN1026_RX_PW_P2              0x13
#define PAN1026_RX_PW_P3              0x14
#define PAN1026_RX_PW_P4              0x15
#define PAN1026_RX_PW_P5              0x16
#define PAN1026_FIFO_STATUS           0x17
#define PAN1026_SETUP_PLL             0x18
#define PAN1026_DEMOD_CAL             0x19
#define PAN1026_RF_CAL2               0x1A
#define PAN1026_DEM_CAL2              0x1B
#define PAN1026_DYNPD                 0x1C
#define PAN1026_FEATURE               0x1D
#define PAN1026_RF_CAL                0x1E
#define PAN1026_BB_CAL                0x1F



/************************  1.8V PAGE 1 Ĵ   ***************************/
#define PAN1026_P1_REG_00             0x00
#define PAN1026_P1_REG_01             0x01
#define PAN1026_P1_REG_02             0x02
#define PAN1026_P1_REG_03             0x03
#define PAN1026_P1_REG_04             0x04
#define PAN1026_P1_REG_05             0x05

#define PAN1026_ACCESS_ADDRESS        0x02


/* 0x00 - CONFIG */
#define XN297L_MODE              0x00   /* XN297Lģʽ */
#define BLE_MODE                 0x40   /* BLEģʽ */
#define	ENABLE_RXIRQ_PIN         0x00   /* RX_DRжϷӳIRQ */
#define	DISABLE_RXIRQ_PIN	 0x20	/* RX_DRжϲӳIRQ */
#define	ENABLE_TXIRQ_PIN	 0x00	/* TX_DSжϷӳIRQ */
#define	DISABLE_TXIRQ_PIN	 0x10	/* TX_DSжϲӳIRQ */
#define	ENABLE_MAX_RT_IRQ_PIN    0x00	/* MAX_RTжϷӳIRQ */
#define	DISABLE_MAX_RT_IRQ_PIN   0x08	/* MAX_RTжϲӳIRQ */
#define CRC_16                   0x04   /* ΪCRC16Уģʽ */
#define CRC_8                    0x00   /* ΪCRC8Уģʽ */
#define ENABLE_CRC               0x02   /* ʹCRCУ */
#define DISABLE_CRC              0x00   /* ֹCRCУ */
#define TX_MODE                  0x00   /* Ϊģʽ */
#define RX_MODE                  0x01   /* Ϊģʽ */
/* 0x01 - EN_AA */
#define ENAA_P0   0x01   /* ʹ pipe0ԶӦ */ 
#define ENAA_P1   0x02   /* ʹ pipe1ԶӦ */  
#define ENAA_P2   0x04   /* ʹ pipe2ԶӦ */  
#define ENAA_P3   0x08   /* ʹ pipe3ԶӦ */  
#define ENAA_P4   0x10   /* ʹ pipe4ԶӦ */  
#define ENAA_P5   0x20   /* ʹ pipe5ԶӦ */  
#define DR_1M     0x00   /*  1M */
#define DR_2M     0x40   /*  2M */
#define DR_250K   0xC0   /*  250K */
/* 0x02 - AW_RXADDR */
#define AW_3BYTES   0x40   /* ַΪ3bytes */
#define AW_4BYTES   0x80   /* ַΪ4bytes */
#define AW_5BYTES   0xc0   /* ַΪ5bytes */
#define ERX_P0 	    0x01   /* ʹܽͨ0 */
#define ERX_P1 	    0x02   /* ʹܽͨ1 */
#define ERX_P2      0x04   /* ʹܽͨ2 */     
#define ERX_P3      0x08   /* ʹܽͨ3 */
#define ERX_P4 	    0x10   /* ʹܽͨ4 */
#define ERX_P5 	    0x20   /* ʹܽͨ5 */
/* 0x19 - DEMOD_CAL */
#define ENABLE_SCR   0x01    /*  */
#define DISABLE_SCR  0x00    /* ر */
/* 0x1C - DYNPD */
#define ENABLE_VCOCAL_ONLY1    0x80    /* VCOУһʹ */
#define DISABLE_VCOCAL_ONLY1   0x00    /* VCOУһιر */
#define NO_IRQ_NO_WORK         0x40    /* IRQFSM */ 
#define NO_IRQ_WORK            0x00    /* IRQFSMҲ */ 
#define DPL_P5                 0x20    /* ʹPIPE5̬PAYLOAD */
#define DPL_P4                 0x10    /* ʹPIPE4̬PAYLOAD */
#define DPL_P3                 0x08    /* ʹPIPE3̬PAYLOAD */
#define DPL_P2                 0x04    /* ʹPIPE2̬PAYLOAD */
#define DPL_P1                 0x02    /* ʹPIPE1̬PAYLOAD */
#define DPL_P0                 0x01    /* ʹPIPE0̬PAYLOAD */
/* 0x1D - FEATURE */
#define IRQ_OUT_NORMAL    0x00   /* IRQ */
#define IRQ_OUT_INV       0x80   /* IRQȡ */
#define IRQ_PIN           0x00   /* IRQźPIN */
#define EN_PA_PIN         0x40   /* EN_AAźPIN */
#define IQ_SW             0x20   /* I/Q Phase switch */
#define PAYLOAD_32        0x00   /* ݳΪ32bytes */
#define PAYLOAD_64        0x18   /* ݳΪ64bytes */
#define DISABLE_DPL       0x00   /* ֹ̬ */
#define ENABLE_DPL        0x04   /* ʹ̬ܶ */
#define DISABLE_ACK_PAY   0x00   /* ֹACKPAYLOAD */
#define ENABLE_ACK_PAY    0x02   /* ʹACKPAYLOAD */
#define DISABLE_DYN_ACK   0x00   /* ֹW_TX_PAYLOAD_NOACK  */
#define ENABLE_DYN_ACK    0x01   /* ʹW_TX_PAYLOAD_NOACK  */



#define BIT0_MASK  (1 << 0)
#define BIT1_MASK  (1 << 1)
#define BIT2_MASK  (1 << 2)
#define BIT3_MASK  (1 << 3)
#define BIT4_MASK  (1 << 4)
#define BIT5_MASK  (1 << 5)
#define BIT6_MASK  (1 << 6)
#define BIT7_MASK  (1 << 7)


#define   D250us          0x00   /* 250usʱ */
#define   D500us          0x10   /* 500usʱ */
#define   D750us          0x20   /* 750usʱ */
#define   D1000us         0x30   /* 1000usʱ */
#define   D1250us         0x40   /* 1250usʱ */
#define   D1500us         0x50   /* 1500usʱ */
#define   D1750us         0x60   /* 1750usʱ */
#define   D2000us         0x70   /* 2000usʱ */
#define   D2250us         0x80   /* 2250usʱ */
#define   D2500us         0x90   /* 2500usʱ */
#define   D2750us         0xA0   /* 2750usʱ */
#define   D3000us         0xB0   /* 3000usʱ */
#define   D3250us         0xC0   /* 3250usʱ */
#define   D3500us         0xD0   /* 3500usʱ */
#define   D3750us         0xE0   /* 3750usʱ */
#define   D4000us         0xF0   /* 4000usʱ */


#define  ARC_NONE         0x00   /* ͨģʽ    */
#define  ARC_0            0x01   /* Զش0 */
#define  ARC_1            0x02   /* Զش1 */
#define  ARC_2            0x03   /* Զش2 */
#define  ARC_3            0x04   /* Զش3 */
#define  ARC_4            0x05   /* Զش4 */
#define  ARC_5            0x06   /* Զش5 */
#define  ARC_6            0x07   /* Զش6 */
#define  ARC_7            0x08   /* Զش7 */
#define  ARC_8            0x09   /* Զش8 */
#define  ARC_9            0x0A   /* Զش9 */
#define  ARC_10           0x0B   /* Զش10 */
#define  ARC_11           0x0C   /* Զش11 */
#define  ARC_12           0x0D   /* Զش12 */
#define  ARC_13           0x0E   /* Զش13 */
#define  ARC_14           0x0F   /* Զش14 */




uint8_t pan1026_init(pan1026_com_interface *interface);
void pan1026_set_mode(uint8_t mode);
void pan1026_deep_sleep(void);
void pan1026_set_channel(uint8_t ch);
void pan1026_set_crc(uint8_t type);
void pan1026_set_power(uint16_t power);
void pan1026_set_rate(uint8_t rate);
void pan1026_set_noack_ackpayload(uint8_t enable);
void pan1026_set_tx_addr(uint8_t *addr, uint8_t addr_len);
void pan1026_set_rx_addr(uint8_t *addr, uint8_t addr_len);
void pan1026_set_addr_width(uint8_t addr_width);
void pan1026_tx_mode(void);
void pan1026_rx_mode(void);
void pan1026_set_rx_payload_len(uint8_t len);
void pan1026_ce_enable(void);
void pan1026_ce_disable(void);
void pan1026_flush_tx_fifo(void);
void pan1026_flush_rx_fifo(void);
void pan1026_clear_status(void);
void pan1026_carrier(void);
void pan1026_send(uint8_t *buf, uint8_t len);
void pan1026_write_ackpayload(uint8_t *buf, uint8_t len);
uint8_t pan1026_get_status(void);
uint8_t pan1026_set_ble_access_addr(uint8_t *addr);
uint8_t pan1026_set_ble_whitelist(uint8_t *filter, uint8_t len, uint8_t en);
uint8_t pan1026_read_ackpayload(uint8_t *buf, const uint8_t maxsize);
uint8_t pan1026_receive(uint8_t *buf, const uint8_t maxsize);
#endif


