#ifndef __CONFIG_RF_H
#define __CONFIG_RF_H

#include "pan1026.h"



/***************************   PAN1026   ******************************/
#define CONFIG_WORK_MODE            PAN1026_BURST_MODE          /* ùģʽΪXN297Lͨ */ 
#define CONFIG_DRIVE_MODE           PAN1026_SPI_NO_MOSI_MODE    /* ӿΪ4SPI */
#define CONFIG_IRQ                  PAN1026_IRQ_ENABLE         /* ʹIRQ */

#define CONFIG_TRX_MODE             PAN1026_TX_MODE             /* RFΪTX MODE */ 
#define CONFIG_PAYLOAD_WIDTH        8                           /* ݳΪ8bytes(Ĭýͨ0) */    
#define CONFIG_CHANNEL              80                          /* ƵΪ2478 Mhz */
#define CONFIG_ADDR_LEN             5                           /* õַΪ5ֽ */ 
#define CONFIG_POWER                PAN1026_POWER_N_8           /* ùΪ10dbm */
#define CONFIG_RATE                 PAN1026_RATE_1M             /* Ϊ1Mbps */

#define CONFIG_SCR                  PAN1026_SCR_ENABLE          /*  */
#define CONFIG_CRC                  PAN1026_CRC16               /* CRCΪCRC16 */
#define CONFIG_RX_PIPE              (ERX_P0)                    /* Ĭϴ򿪽ͨ0,ʹͨöӦͨĽճ */

#define PAN1026_BLE_DEFAULT_CHANNEL     80
#define PAN1026_BURST_DEFAULT_CHANNEL   CONFIG_CHANNEL 

#define CONFIG_ADDR_BYTE0      0xCC
#define CONFIG_ADDR_BYTE1      0xCC
#define CONFIG_ADDR_BYTE2      0xCC
#define CONFIG_ADDR_BYTE3      0xCC
#define CONFIG_ADDR_BYTE4      0xCC
#if (CONFIG_ADDR_LEN == 3)
    #define CONFIG_ADDR        {CONFIG_ADDR_BYTE0, CONFIG_ADDR_BYTE1, CONFIG_ADDR_BYTE2}
#elif (CONFIG_ADDR_LEN == 4)                                                  
    #define CONFIG_ADDR        {CONFIG_ADDR_BYTE0, CONFIG_ADDR_BYTE1, CONFIG_ADDR_BYTE2, CONFIG_ADDR_BYTE3}
#else                                                                      
    #define CONFIG_ADDR        {CONFIG_ADDR_BYTE0, CONFIG_ADDR_BYTE1, CONFIG_ADDR_BYTE2, CONFIG_ADDR_BYTE3, CONFIG_ADDR_BYTE4}
#endif



/* ǿģʽ */
#if(CONFIG_WORK_MODE == PAN1026_ENHANCE_MODE)
  #define CONFIG_AUTO_ACK_PIPE        (ENAA_P0)                 /* ʹ pipe0ԶӦ */
  #define CONFIG_AUTO_RETR            (D250us | ARC_1 )         /* Զʱ250us, ackش1 */

  #define  CONFIG_DYN_ACK              ENABLE_DYN_ACK           /* ʹ W_TX_PAYLOAD_NOACK  */
  #define  CONFIG_ACK_PAY              ENABLE_ACK_PAY           /* ʹ ACKPAYLOAD */
  #define  CONFIG_DPL                  DISABLE_DPL              /* ĬϹرն̬ PAYLOAD */
#else
  #define CONFIG_AUTO_ACK_PIPE         0x00                     /* رԶӦ */
  #define CONFIG_AUTO_RETR             0x00                        

  #define  CONFIG_DYN_ACK              DISABLE_DYN_ACK           
  #define  CONFIG_ACK_PAY              DISABLE_ACK_PAY
  #define  CONFIG_DPL                  DISABLE_DPL
#endif

/* ʹ˶̬PAYLOAD(ǿģʽ), Ҫ CONFIG_DPLCONFIG_AUTO_ACK_PIPE*/
#if(CONFIG_DPL == ENABLE_DPL)
  #define CONFIG_DPL_PIPE              (DPL_P0)
#else
  #define CONFIG_DPL_PIPE               0x00
#endif



/* BLEģʽ */
#if(CONFIG_WORK_MODE == PAN1026_BLE_MODE)
  #define CONFIG_BLE_FILTER          PAN1026_BLE_FILTER_DISABLE /* رӲ˹ܣӲֻܹADV DATAȴ8bytes */
  #define CONFIG_BLE_FILTER_BYTE0    0x00
  #define CONFIG_BLE_FILTER_BYTE1    0xC7
  #define CONFIG_BLE_FILTER_ADDR     {CONFIG_BLE_FILTER_BYTE0, CONFIG_BLE_FILTER_BYTE1}  
#endif

#endif
