#include "cw32r031_gpio.h"
#include "key.h"
#include "APP.h"
#include "delay.h"

uint8_t ucKey, ucKey_Temp, ucKey_RD;
uint16_t ucKey_Debounce = 0;
uint8_t ucADC_Level;
uint8_t flag_key_one_shot = 0;

/**
 * @brief  IOʼ
 * @param  None
 * @retval None
 */
void Key_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct;

  __RCC_GPIOB_CLK_ENABLE();

  GPIO_InitStruct.IT = GPIO_IT_NONE;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pins = GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5;
  GPIO_Init(CW_GPIOB, &GPIO_InitStruct);

  delay10us(50);
  ucKey = 0; /* ǰ״ֵ̬,ɨĽڴ˱ */
  ucKey_Debounce = ucKey_Debounce + 1;
  ucKey = Key_Rd();
  ucKey_Temp = ucKey;
  ucKey_RD = ucKey_Temp; /* ǰ״ֵ̬,жϴ˱ֵȷʲô */
}

/**
 * @brief  ȡĸ
 * @param  None
 * @retval ±ʶ
 */
uint8_t Key_Rd(void)
{
  uint8_t ucKey_D;

  ucKey_D = 0;
  if (~KEY1_STATUS)
  {
    ucKey_D |= 0x01;
  }
  if (~KEY2_STATUS)
  {
    ucKey_D |= 0x02;
  }
  if (~KEY3_STATUS)
  {
    ucKey_D |= 0x04;
  }
  return ucKey_D;
}

/**
 * @brief  ɨ裬аʱֵDATA_READYΪTRUE
 * @param  None
 * @retval None
 */
void Key_Scan(void)
{
  ucKey = Key_Rd();

  if (ucKey != ucKey_Temp)
  {
    ucKey_Temp = ucKey;
    ucKey_Debounce = 0;
  }
  else if (ucKey_Debounce < KEY_DEBOUNCE_TIME)
  {
    ucKey_Debounce++;
  }
  else if (ucKey_Debounce == KEY_DEBOUNCE_TIME)
  {
    ucKey_RD = ucKey_Temp;
    DATA_READY = TRUE;
    ucKey_Debounce++;
  }
}
